## pfstools 2.0.4

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.8)
project(pfstools)

set(CPACK_GENERATOR TGZ)
set(CPACK_SOURCE_GENERATOR TGZ)
# CPack version numbers for release tarball name.
set(CPACK_PACKAGE_VERSION_MAJOR 2)
set(CPACK_PACKAGE_VERSION_MINOR 0)
set(CPACK_PACKAGE_VERSION_PATCH 4)
set(CPACK_SOURCE_IGNORE_FILES
"~$"
"\\\\.cvsignore$"
"^${PROJECT_SOURCE_DIR}.*/CVS/"
"^${PROJECT_SOURCE_DIR}/debian/"
"^${PROJECT_SOURCE_DIR}/old/"
)
include( CPack )

#SET(ZLIB_DIR "e:/zlib/")
#SET(CMAKE_INCLUDE_PATH ${ZLIB_DIR}/include ${CMAKE_INCLUDE_PATH})
#SET(CMAKE_LIBRARY_PATH ${ZLIB_DIR}/ ${ZLIB_DIR}/lib ${CMAKE_LIBRARY_PATH})

if( "${CYGWIN}" STREQUAL "" )
  set(CYGWIN 0)  
endif( "${CYGWIN}" STREQUAL "" )

set (pfstools_VERSION_MAJOR 2)
set (pfstools_VERSION_MINOR 0.0)
set (pfslib_version 1.2)
set(CMAKE_LEGACY_CYGWIN_WIN32 0)
 
set (MAN_DIR "${CMAKE_INSTALL_PREFIX}/share/man/man1" CACHE PATH "The directory where the man pages are")

include( CheckCXXSourceCompiles )


# ======== Check for OpenMP =======

find_package(OpenMP)
if( OPENMP_FOUND )
  set( HAVE_OpenMP 1 )
else( OPENMP_FOUND )
  set( HAVE_OpenMP 0 )
endif( OPENMP_FOUND )
  

# ======== Has branch prediction =======

check_cxx_source_compiles( "int main() { int x = 0; if( __builtin_expect((x),0) ) x = 1; return 0; }" HAS_BRANCH_PEDICTION )

if( HAS_BRANCH_PREDICTION )
  set( BRANCH_PREDICTION 1 )
else( HAS_BRANCH_PREDICTION )
  set( BRANCH_PREDICTION 0 )
endif( HAS_BRANCH_PREDICTION )

# ======== Find bash =======

# TODO: What if the check fails
find_program (BASH_EXECUTABLE bash)
message( "Using bash: ${BASH_EXECUTABLE}" )

# ======== Find perl =======

find_program (PERL_EXECUTABLE perl)
if( PERL_EXECUTABLE )
	message( "Using perl: ${PERL_EXECUTABLE}" )
else( PERL_EXECUTABLE )
	message( "Perl interpreter not found. Reading multiple exposures (pfsinhdrgen, pfsinme) will not work" )
endif( PERL_EXECUTABLE )

# ======== Build static or dynamic libraries =======

OPTION (BUILD_SHARED_LIBS "Build pfs as a shared library" OFF)
# TODO: Shared libs do not work with VS. Add declspec as explained at: http://www.cmake.org/Wiki/BuildingWinDLL
# Set the LIB_TYPE variable to STATIC
SET (LIB_TYPE STATIC)
IF (BUILD_SHARED_LIBS)
  SET (LIB_TYPE SHARED)
ENDIF (BUILD_SHARED_LIBS)

# ======== Check for getopt, which is missing on Windows ========

check_cxx_source_compiles( "#include \"getopt.h\" \n int main() { return 0; }" HAS_GETOPT )
if( NOT HAS_GETOPT )
  MESSAGE( STATUS "getopt not found, a replacement needs to be compiled. " )
  set( GETOPT_INCLUDE "${PROJECT_SOURCE_DIR}/src/getopt" )
  set( GETOPT_OBJECT "$<TARGET_OBJECTS:getopt>" )
else( NOT HAS_GETOPT )
  MESSAGE( STATUS "getopt found. " )
  set( GETOPT_INCLUDE ".") # work around, cannot pass empty string
  set( GETOPT_OBJECT )
endif( NOT HAS_GETOPT )

set( CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake )

# ======== OpenEXR ===========

OPTION(WITH_OpenEXR "Compile with OpenEXR library" ON)

if( WITH_OpenEXR )

find_package (OpenEXR)
if( NOT OPENEXR_FOUND )
MESSAGE( STATUS "OpenEXR not found. The following command will not be
compiled: pfsinexr pfsoutexr. " )
endif( NOT OPENEXR_FOUND )

endif( WITH_OpenEXR )

# ======== Image Magick ===========

OPTION(WITH_ImageMagick "Use ImageMagick library" ON)

if( WITH_ImageMagick )

find_package(ImageMagick COMPONENTS Magick++ MagickCore)
if( NOT ImageMagick_FOUND )
MESSAGE( STATUS "ImageMagick not found. The following commands will not be
compiled: pfsinimgmagick pfsoutimgmagick pfsouthdrhtml. " )
endif( NOT ImageMagick_FOUND )

else( WITH_ImageMagick )

      set( ImageMagick_FOUND OFF )

endif( WITH_ImageMagick )

message( "ImageMagick CFLAGS: " ${ImageMagick_INCLUDE_DIRS} )

# ======== NetPBM ===========

#include( ${PROJECT_SRC_DIR}/cmake/FindNETPBM.cmake )

OPTION(WITH_NetPBM "Use NetPBM library" ON)

if( WITH_NetPBM )

    find_package(NETPBM)
    if( NOT NETPBM_FOUND )
    	MESSAGE( STATUS "NetPBM not found. The following commands will
    not be compiled: pfsinppm pfsoutppm. " )
    endif( NOT NETPBM_FOUND )

else( WITH_NetPBM )

      set( NETPBM_FOUND OFF )

endif( WITH_NetPBM )

# ======== TIFF ===========

#include( ${PROJECT_SRC_DIR}/cmake/FindTIDD.cmake )

OPTION(WITH_TIFF "Use TIFF library" ON)

if( WITH_TIFF )

    find_package(TIFF)
    if( NOT TIFF_FOUND )
    	MESSAGE( STATUS "TIFF not found. The following commands will
    not be compiled: pfsintiff pfsouttiff. " )
    endif( NOT TIFF_FOUND )

else( WITH_TIFF )

      set( NETPBM_FOUND OFF )

endif( WITH_TIFF )

# ======== QT ===========

OPTION(WITH_QT "Use QT library" ON)

if( WITH_QT )

    find_package(Qt4)
    if( NOT QT_FOUND )
    	MESSAGE( STATUS "Qt4 library not found. The following commands
    will not be compiled: pfsview. " )
    else( NOT QT_FOUND )
        MESSAGE( STATUS "Qt4 found" )
    endif( NOT QT_FOUND )

else( WITH_QT )

      set( QT_FOUND OFF )

endif( WITH_QT )

# ======== Matlab ===========

OPTION(WITH_MATLAB "Compile Matlab MEX files" ON)

SET (MATLAB_DEST_DIR "${CMAKE_INSTALL_PREFIX}/share/pfstools/pfstools_matlab"
CACHE PATH  "Copy matlab functions to this directory")

if( WITH_MATLAB )
  find_package(MATLAB)

  if( MATLAB_FOUND )
    message(STATUS "matlab found.")
  elseif( MATLAB_FOUND )
    message( STATUS "Matlab or mex compiler not found. Matlab integration will not be compiled." )
  endif( MATLAB_FOUND )
  
endif( WITH_MATLAB )


#include( FindPkgConfig.cmake )

# ======== OpenGL ===========

OPTION(WITH_pfsglview "Compile pfsglview, requires OpenGL and GLUT" ON)

if( WITH_pfsglview )

find_path(OPENGL_INCLUDE_DIR GL/gl.h )

find_package(OpenGL )
find_package(GLUT )

if( NOT OPENGL_FOUND )
	MESSAGE( STATUS "OpenGL not found. The following command will not be
compiled: pfsglview. " )
endif( NOT OPENGL_FOUND )

if( NOT GLUT_FOUND )
	MESSAGE( STATUS "GLUT not found. The following command will not be
compiled: pfsglview. " )
endif( NOT GLUT_FOUND )

endif( WITH_pfsglview )

# ========= FFTW  ===========

OPTION(WITH_FFTW "Use fftw to speed up some operations" ON)

if( WITH_FFTW )

  find_package (FFTW)

  if( NOT FFTW_FOUND )
    MESSAGE( STATUS "FFTW library not found. Acceleration for pfstmo_durand02 disabled. " )
    set( HAVE_FFTW3F 0 )
    set( HAVE_FFTW3 0 )
  else( NOT FFTW_FOUND )
    set( HAVE_FFTW3F 1 )
    set( HAVE_FFTW3 1 )
  endif( NOT FFTW_FOUND )

else( WITH_FFTW )
  set( HAVE_FFTW3F 0 )
  set( HAVE_FFTW3 0 )
endif( WITH_FFTW )


# ========= GSL  ===========

OPTION(WITH_GSL "Use Gnu Scientific Libarary required for some TMOs" ON)

if( WITH_GSL )

find_package (GSL)

if( NOT GSL_FOUND )
	MESSAGE( STATUS "GSL library not found. pfstmo_mantiuk08 will not be compiled." )
endif( NOT GSL_FOUND )

endif( WITH_GSL )


# ======== HDRVC ===========
# This is an experimental implementation of HDR-MPEG codec, not included in the official release.
OPTION(WITH_HDRVC "Compile HDRVC (internal release only)" OFF)

# ======== MKOCTFILE/OCTAVE ===========

OPTION(WITH_Octave "Compile Octave files" ON)
SET (OCTAVE_DEST_DIR "${CMAKE_INSTALL_PREFIX}/share/pfstools/octave"
CACHE PATH  "Copy octave functions to this directory")

if( WITH_Octave )
  
  find_program(MKOCTFILE mkoctfile)
  if(NOT MKOCTFILE)
    message(STATUS "Failed to find mkoctfile. Maybe liboctave-dev is not installed.")
  endif()
  if(MKOCTFILE)
    message(STATUS "mkoctfile found.")
  endif()

endif( WITH_Octave )

# ======== OpenCV ===========

OPTION(WITH_OpenCV "Use OpenCV library requires for pfsalign" ON)

if( WITH_OpenCV )

  find_package( OpenCV )

  if( NOT OpenCV_FOUND )
    message( "OpenCV library not found. 'pfsalign' will not be compiled" )
  else( NOT OpenCV_FOUND )
    message(STATUS "OpenCV library found.")  
  endif( NOT OpenCV_FOUND )

endif( WITH_OpenCV )

# ======== libexif ==========

find_package(EXIF)
if( NOT EXIF_FOUND )
    message( "EXIF library (libexif) not found. 'pfsalign' will not be compiled" )
else( NOT EXIF_FOUND )
    message(STATUS "libexif library found.")  
endif( NOT EXIF_FOUND )

# ======== Config and sub dirs ===========

set(PKG_DATADIR "${CMAKE_INSTALL_PREFIX}/share/pfstools")
configure_file (
  "${PROJECT_SOURCE_DIR}/cmake_config.h.in"
  "${PROJECT_BINARY_DIR}/config.h"
  )

add_subdirectory (src)

=== src/CMakeLists.txt ===
if( NOT HAS_GETOPT )
  add_subdirectory (getopt)
endif( NOT HAS_GETOPT )

add_subdirectory (pfs) 
add_subdirectory (fileformat) 
add_subdirectory (filter)

if( ImageMagick_FOUND )
    add_subdirectory (hdrhtml)
endif( ImageMagick_FOUND )

if( QT_FOUND )
    add_subdirectory (pfsview)
endif( QT_FOUND )

if( MATLAB_FOUND )
    add_subdirectory (matlab)
endif( MATLAB_FOUND )

if( OPENGL_FOUND AND GLUT_FOUND )
    add_subdirectory (pfsglview)
endif( OPENGL_FOUND AND GLUT_FOUND )

if( WITH_HDRVC )
	add_subdirectory (hdrvc)
endif( WITH_HDRVC )

if( MKOCTFILE )
	add_subdirectory (octave)
endif( MKOCTFILE )

add_subdirectory (tmo)
add_subdirectory (camera)

=== src/camera/CMakeLists.txt ===
include_directories ("${PROJECT_BINARY_DIR}/"
"${PROJECT_SOURCE_DIR}/src/pfs" "${CMAKE_CURRENT_SOURCE_DIR}")

link_directories("${PROJECT_SOURCE_DIR}/src/pfs")

set(TRG pfshdrcalibrate)
add_executable(${TRG} ${TRG}.cpp  responses.cpp robertson02.cpp  mitsunaga99.cpp  mitsunaga99_numerical.cpp nrutil.cpp "${GETOPT_OBJECT}")			  
target_link_libraries(${TRG} pfs)
install (TARGETS ${TRG} DESTINATION bin)
install (FILES ${TRG}.1 DESTINATION ${MAN_DIR})

if( OpenCV_FOUND AND EXIF_FOUND )
  
	set(TRG pfsalign)
	add_executable(${TRG} ${TRG}.cpp  "${GETOPT_OBJECT}")			  
	target_link_libraries(${TRG} pfs ${OpenCV_LIBS}
	${EXIF_LIBRARIES})
	include_directories( ${EXIF_INCLUDE_DIRS} )
	install (TARGETS ${TRG} DESTINATION bin)
	install (FILES ${TRG}.1 DESTINATION ${MAN_DIR})

endif( OpenCV_FOUND AND EXIF_FOUND )


# Shell scripts
set(SCRIPTS dcraw2hdrgen jpeg2hdrgen pfsinme pfsplotresponse pfsinhdrgen) 

foreach(SCRIPT ${SCRIPTS}) 

	# Replace the tag with the path to bash
	file(READ ${CMAKE_CURRENT_SOURCE_DIR}/${SCRIPT}.in file_content)
	string(REGEX REPLACE "@BASH_PATH@" "${BASH_EXECUTABLE}" file_content "${file_content}")
	string(REGEX REPLACE "@PERL_PATH@" "${PERL_EXECUTABLE}" file_content "${file_content}")
	file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT}" "${file_content}")	

	install (FILES "${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT}" 
         PERMISSIONS OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE OWNER_WRITE WORLD_READ GROUP_READ OWNER_READ
         DESTINATION bin)	
		 
	install (FILES ${SCRIPT}.1 DESTINATION ${MAN_DIR})
		 
endforeach(SCRIPT)

=== src/fileformat/CMakeLists.txt ===
include_directories ("${PROJECT_BINARY_DIR}/" "${PROJECT_SOURCE_DIR}/src/pfs")
if( NOT HAS_GETOPT )
	include_directories ("${GETOPT_INCLUDE}")
endif( NOT HAS_GETOPT )

link_directories("${PROJECT_SOURCE_DIR}/src/pfs")


# Replace the tag with the path to bash
file(READ ${CMAKE_CURRENT_SOURCE_DIR}/pfsin.in file_content)
string(REGEX REPLACE "@BASH_PATH@" "${BASH_EXECUTABLE}" file_content "${file_content}")
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/pfsin" "${file_content}")	

file(READ ${CMAKE_CURRENT_SOURCE_DIR}/pfsout.in file_content)
string(REGEX REPLACE "(@BASH_PATH@)" "${BASH_EXECUTABLE}" file_content "${file_content}")
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/pfsout" "${file_content}")	

file(READ ${CMAKE_CURRENT_SOURCE_DIR}/pfsindcraw.in file_content)
string(REGEX REPLACE "(@BASH_PATH@)" "${BASH_EXECUTABLE}" file_content "${file_content}")
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/pfsindcraw" "${file_content}")	


install (FILES "${CMAKE_CURRENT_BINARY_DIR}/pfsin" "${CMAKE_CURRENT_BINARY_DIR}/pfsout" 
         "${CMAKE_CURRENT_BINARY_DIR}/pfsindcraw" 
         PERMISSIONS OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE OWNER_WRITE WORLD_READ GROUP_READ OWNER_READ
         DESTINATION bin)

install (FILES pfsin.1 DESTINATION ${MAN_DIR})
install (FILES pfsindcraw.1 DESTINATION ${MAN_DIR})
install (FILES pfsout.1 DESTINATION ${MAN_DIR})
		 
		 
add_executable(pfsinrgbe pfsinrgbe.cpp rgbeio.cpp rgbeio.h "${GETOPT_OBJECT}")
target_link_libraries(pfsinrgbe pfs)
install (TARGETS pfsinrgbe DESTINATION bin)
install (FILES pfsinrgbe.1 DESTINATION ${MAN_DIR})

add_executable(pfsoutrgbe pfsoutrgbe.cpp rgbeio.cpp rgbeio.h "${GETOPT_OBJECT}") 
target_link_libraries(pfsoutrgbe pfs)
install (TARGETS pfsoutrgbe DESTINATION bin)
install (FILES pfsoutrgbe.1 DESTINATION ${MAN_DIR})

add_executable(pfsinpfm pfsinpfm.cpp "${GETOPT_OBJECT}")
target_link_libraries(pfsinpfm pfs)
install (TARGETS pfsinpfm DESTINATION bin)
install (FILES pfsinpfm.1 DESTINATION ${MAN_DIR})

add_executable(pfsoutpfm pfsoutpfm.cpp "${GETOPT_OBJECT}")
target_link_libraries(pfsoutpfm pfs)
install (TARGETS pfsoutpfm DESTINATION bin)
install (FILES pfsoutpfm.1 DESTINATION ${MAN_DIR})

if( OPENEXR_FOUND )
    include_directories("${OPENEXR_INCLUDE_DIR}")

    add_executable(pfsinexr pfsinexr.cpp "${GETOPT_OBJECT}")
    target_link_libraries(pfsinexr pfs ${OPENEXR_LIBRARIES})
    install (TARGETS pfsinexr DESTINATION bin)
    install (FILES pfsinexr.1 DESTINATION ${MAN_DIR})

    add_executable(pfsoutexr pfsoutexr.cpp "${GETOPT_OBJECT}")
    target_link_libraries(pfsoutexr pfs ${OPENEXR_LIBRARIES})
    install (TARGETS pfsoutexr DESTINATION bin)
    install (FILES pfsoutexr.1 DESTINATION ${MAN_DIR})
 endif( OPENEXR_FOUND )

if( ImageMagick_FOUND )
    include_directories(${ImageMagick_INCLUDE_DIRS})
    add_executable(pfsinimgmagick pfsinimgmagick.cpp "${GETOPT_OBJECT}")
    target_link_libraries(pfsinimgmagick pfs ${ImageMagick_LIBRARIES})
    install (TARGETS pfsinimgmagick DESTINATION bin)
    install (FILES pfsinimgmagick.1 DESTINATION ${MAN_DIR})
    set_target_properties(pfsinimgmagick PROPERTIES COMPILE_FLAGS "-DMAGICKCORE_HDRI_ENABLE=0 -DMAGICKCORE_QUANTUM_DEPTH=16")

    add_executable(pfsoutimgmagick pfsoutimgmagick.cpp "${GETOPT_OBJECT}")
    target_link_libraries(pfsoutimgmagick pfs ${ImageMagick_LIBRARIES})
    install (TARGETS pfsoutimgmagick DESTINATION bin)
    install (FILES pfsoutimgmagick.1 DESTINATION ${MAN_DIR})
    set_target_properties(pfsoutimgmagick PROPERTIES COMPILE_FLAGS "-DMAGICKCORE_HDRI_ENABLE=0 -DMAGICKCORE_QUANTUM_DEPTH=16")

endif( ImageMagick_FOUND )

if( NETPBM_FOUND )

    include_directories(${NETPBM_INCLUDE_DIR})

    add_executable(pfsinppm pfsinppm.cpp ppmio.cpp "${GETOPT_OBJECT}")
    target_link_libraries(pfsinppm pfs ${NETPBM_LIBRARIES})
    install (TARGETS pfsinppm DESTINATION bin)
    install (FILES pfsinppm.1 DESTINATION ${MAN_DIR})

    add_executable(pfsoutppm pfsoutppm.cpp ppmio.cpp "${GETOPT_OBJECT}")
    target_link_libraries(pfsoutppm pfs ${NETPBM_LIBRARIES})
    install (TARGETS pfsoutppm DESTINATION bin)
    install (FILES pfsoutppm.1 DESTINATION ${MAN_DIR})

endif( NETPBM_FOUND )

if( TIFF_FOUND )

    include_directories(${TIFF_INCLUDE_DIR})

    add_executable(pfsintiff pfsintiff.cpp hdrtiffio.cpp "${GETOPT_OBJECT}")
    target_link_libraries(pfsintiff pfs ${TIFF_LIBRARY})
    install (TARGETS pfsintiff DESTINATION bin)
    install (FILES pfsintiff.1 DESTINATION ${MAN_DIR})

    add_executable(pfsouttiff pfsouttiff.cpp hdrtiffio.cpp "${GETOPT_OBJECT}")
    target_link_libraries(pfsouttiff pfs ${TIFF_LIBRARY})
    install (TARGETS pfsouttiff DESTINATION bin)
    install (FILES pfsoutppm.1 DESTINATION ${MAN_DIR} RENAME pfsouttiff.1)

endif( TIFF_FOUND )

=== src/filter/CMakeLists.txt ===
include_directories ("${PROJECT_BINARY_DIR}/" "${PROJECT_SOURCE_DIR}/src/pfs")
if( NOT HAS_GETOPT )
	include_directories ("${GETOPT_INCLUDE}")
endif( NOT HAS_GETOPT )
link_directories("${PROJECT_SOURCE_DIR}/src/pfs")

set(PFS_FILT pfsgamma pfsclamp pfstag pfssize pfsextractchannels
pfspanoramic pfsrotate pfsflip pfscut pfspad pfscat pfsabsolute pfsretime
pfscolortransform) 

foreach(TRG ${PFS_FILT}) 
    add_executable(${TRG} ${TRG}.cpp "${GETOPT_OBJECT}")
    target_link_libraries(${TRG} pfs)
    install (TARGETS ${TRG} DESTINATION bin)
    install (FILES ${TRG}.1 DESTINATION ${MAN_DIR})
 endforeach(TRG) 

add_executable(pfsdisplayfunction pfsdisplayfunction.cpp display_function.cpp display_function.h "${GETOPT_OBJECT}")
target_link_libraries(pfsdisplayfunction pfs)
install (TARGETS pfsdisplayfunction DESTINATION bin)
install (FILES pfsdisplayfunction.1 DESTINATION ${MAN_DIR})

=== src/getopt/CMakeLists.txt ===

include_directories ("${PROJECT_BINARY_DIR}/")
add_library(getopt OBJECT getopt.c getopt.h)

=== src/matlab/CMakeLists.txt ===
include_directories ("${PROJECT_BINARY_DIR}/" "${PROJECT_SOURCE_DIR}/src/pfs")

#include_directories ("${PROJECT_BINARY_DIR}/" "${PROJECT_SOURCE_DIR}/src/pfs" ${MATLAB_INCLUDE_DIR})

link_directories("${PROJECT_SOURCE_DIR}/src/pfs")

execute_process(COMMAND ${MATLAB_ROOT}/bin/mexext OUTPUT_VARIABLE MEX_EXT OUTPUT_STRIP_TRAILING_WHITESPACE)

message( "Matlab: mexext: ${MEX_EXT}" )
set(SRCMEX pfsclose.cpp pfsopen.cpp pfspopen.cpp pfsput.cpp pfsget.cpp pfs_transform_colorspace.cpp pfspclose.cpp) 

set(SRCM Contents.m pfs_read_image.m pfs_read_luminance.m
pfs_read_rgb.m pfs_read_xyz.m pfs_shell.m pfs_test_shell.m
pfs_write_image.m pfs_write_luminance.m pfs_write_rgb.m
pfs_write_xyz.m pfsview.m pfsview_rgb.m ) 

cmake_policy(SET CMP0018 OLD)

SET( CMAKE_CXX_COMPILER ${MATLAB_MEX} )
SET( CMAKE_C_COMPILER   ${MATLAB_MEX} )
# Suffix and Prefix of the output target file
SET( CMAKE_SHARED_LIBRARY_SUFFIX ".${MEX_EXT}" )  # set suffix to .mexa64
SET( CMAKE_SHARED_LIBRARY_PREFIX )      # remove the "lib" prefix
 
# Variables controlling the build-phrase
SET( CMAKE_CXX_FLAGS "-cxx -largeArrayDims" )
#SET( CMAKE_CXX_FLAGS "-cxx -largeArrayDims CXXFLAGS='$$CXXFLAGS -std=c++11'" )
SET( CMAKE_SHARED_LIBRARY_CXX_FLAGS )       # remove the -fPIC option. mex does not accept the "-fPIC" option
 
SET( CMAKE_CXX_COMPILE_OBJECT 
    "<CMAKE_CXX_COMPILER> <DEFINES> <FLAGS> -outdir <OBJECT_DIR> -c <SOURCE>; mv <OBJECT_DIR>/$$(basename <SOURCE> .cpp ).o <OBJECT>"
#    "<CMAKE_CXX_COMPILER> <DEFINES> <FLAGS> -outdir <OBJECT_DIR> -c <SOURCE>"
)
 
# Variables controlling the linking-phase
SET( CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS )    # remove -shared options. mex does not accept the "-shared" option
 
SET(
    CMAKE_CXX_CREATE_SHARED_LIBRARY
    "<CMAKE_CXX_COMPILER> -cxx <LINK_FLAGS> <CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS> -output <TARGET> <OBJECTS> <LINK_LIBRARIES> LDFLAGS='$LDFLAGS -static-libstdc++'"
)

#

#SET( CMAKE_SKIP_RPATH TRUE ) 
# Variables controlling the installation RPATH
SET( CMAKE_INSTALL_RPATH "\$ORIGIN" )

# CMake will reset RPATH at the installation phase, so we need to specify CMAKE_INSTALL_RPATH

SET( CMAKE_SKIP_RPATH TRUE ) 

MESSAGE( STATUS "mex.cmake is loaded.\n" )
 
 
## To add an mex file, you can:
#  ADD_LIBRARY( myprogram SHARED myprogram.cxx )
## Make sure you specify it as SHARED, and make sure you use the cxx extension. 

add_definitions(-DMATLAB_MEX_FILE) 
foreach(SRC ${SRCMEX}) 
  get_filename_component(MEXNAME ${SRC} NAME_WE) 
  add_library(${MEXNAME} SHARED ${SRC} mex_utils.cpp ${MEXDEFFILE}) 
#  target_link_libraries(${MEXNAME} pfs ${MATLAB_LIBRARIES}) 
  target_link_libraries(${MEXNAME} pfs ) 
#  set_target_properties(${MEXNAME} PROPERTIES PREFIX "" SUFFIX 
#".${MEX_EXT}") 

  install (TARGETS ${MEXNAME} DESTINATION ${MATLAB_DEST_DIR})
  install (FILES ${MEXNAME}.m DESTINATION ${MATLAB_DEST_DIR})

endforeach(SRC) 

foreach(SRC ${SRCM}) 
  install (FILES ${SRC} DESTINATION ${MATLAB_DEST_DIR})
endforeach(SRC)

=== src/octave/CMakeLists.txt ===
include_directories("${PROJECT_BINARY_DIR}/" "${PROJECT_SOURCE_DIR}/src/pfs" "${PROJECT_SOURCE_DIR}/src/octave/help_files" ${OCTAVE_DEST_DIR})
link_directories("${PROJECT_SOURCE_DIR}/src/pfs")

set(HELP_FILES pfsget.help pfsopen.help pfsput.help pfsread.help pfstransform_colorspace.help pfswrite.help)

set(SRC_OCT pfsread pfswrite pfstransform_colorspace pfsopen pfsget pfsput pfsclose)

set(SRC_M pfsview.m pfsview_rgb.m pfsview_list.m pfs_read_rgb.m pfs_read_xyz.m pfs_read_luminance.m pfs_write_rgb.m pfssize.m pfs_open_frames.m pfs_close_frames.m)

set(OCT_SCRIPTS pfsoctavelum pfsoctavergb pfsstat)

set(CMAKE_CXXFLAGS "-cxx -largeArrayDims")
set(ENV{CXXFLAGS} ${CMAKE_CXXFLAGS})

SET( CMAKE_CXX_COMPILER MKOCTFILE )
SET( CMAKE_C_COMPILER   MKOCTFILE )

SET( CMAKE_SHARED_LIBRARY_PREFIX )

set(HEADERS "${PROJECT_SOURCE_DIR}/src/pfs/")

#Building phase
foreach(SRC ${SRC_OCT})
  get_filename_component(OCT_NAME ${SRC} NAME)
  add_custom_command(
	OUTPUT ${OCT_NAME}.oct
	COMMAND ${MKOCTFILE} "${CMAKE_CURRENT_SOURCE_DIR}/${OCT_NAME}.cpp"
	ARGS -I${HEADERS} -I${CMAKE_CURRENT_SOURCE_DIR}/help_files
	-L${PROJECT_BINARY_DIR}/src/pfs -lpfs
	DEPENDS ${OCT_NAME}.cpp
	COMMENT "Generating ${OCT_NAME}.oct"
	VERBATIM)
endforeach(SRC)

foreach(SRC ${SRC_OCT})
	add_custom_target(${SRC}.mkoct ALL DEPENDS ${SRC}.oct)
endforeach(SRC)

#Installation
foreach(SRC ${SRC_OCT}) 
	install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${SRC}.oct 
	         PERMISSIONS OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE OWNER_WRITE WORLD_READ GROUP_READ OWNER_READ
	         DESTINATION ${OCTAVE_DEST_DIR})
endforeach(SRC)

foreach(SRC ${SRC_M}) 
	install (FILES ${SRC} DESTINATION ${OCTAVE_DEST_DIR})
endforeach(SRC)

install (FILES ${OCT_SCRIPTS} 
         PERMISSIONS OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE OWNER_WRITE WORLD_READ GROUP_READ OWNER_READ
         DESTINATION bin)
		 
foreach(SCRIPT ${OCT_SCRIPTS})

install (FILES ${SCRIPT}.1 DESTINATION ${MAN_DIR})

endforeach(SCRIPT ${OCT_SCRIPTS})

=== src/pfsglview/CMakeLists.txt ===

include_directories ("${PROJECT_BINARY_DIR}/" "${PROJECT_SOURCE_DIR}/src/pfs" ${OPENGL_INCLUDE_DIRS}  ${GLUT_INCLUDE_DIRS})
if( NOT HAS_GETOPT )
	include_directories ("${GETOPT_INCLUDE}")
endif( NOT HAS_GETOPT )

if (OPENMP_FOUND)
#    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
endif()

add_executable(pfsglview pfsglview.cpp picture_io.cpp module.cpp m_histogram.cpp m_status.cpp m_on_screen_display.cpp)

# TODO: Use ${GLUT_LIBRARY} instead.
target_link_libraries(pfsglview ${OPENGL_LIBRARIES} ${GLUT_glut_LIBRARY} pfs)

install (TARGETS pfsglview DESTINATION bin)
install (FILES pfsglview.1 DESTINATION ${MAN_DIR})

=== src/pfsview/CMakeLists.txt ===
include_directories ("${PROJECT_BINARY_DIR}/" "${PROJECT_SOURCE_DIR}/src/pfs" ${QT_INCLUDES})
if( NOT HAS_GETOPT )
	include_directories ("${GETOPT_INCLUDE}")
endif( NOT HAS_GETOPT )

#include_directories ("${PROJECT_BINARY_DIR}/" "${PROJECT_SOURCE_DIR}/src/pfs" ${QT_QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR})
link_directories("${PROJECT_SOURCE_DIR}/src/pfs")

SET(pfsview_SOURCES main.cpp pfsview_widget.cpp luminancerange_widget.cpp histogram.cpp resources.cpp)
SET(pfsview_HEADERS main.h pfsview_widget.h luminancerange_widget.h)

if (OPENMP_FOUND)
#    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
endif()

QT4_WRAP_CPP(pfsview_HEADERS_MOC ${pfsview_HEADERS})

QT4_WRAP_CPP(pfsview_HEADERS_MOC ${pfsview_HEADERS})

# Replace the tag with the path to bash
file(READ ${CMAKE_CURRENT_SOURCE_DIR}/pfsv.in file_content)
string(REGEX REPLACE "@BASH_PATH@" "${BASH_EXECUTABLE}" file_content "${file_content}")
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/pfsv" "${file_content}")	

install (FILES "${CMAKE_CURRENT_BINARY_DIR}/pfsv" 
         PERMISSIONS OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE OWNER_WRITE WORLD_READ GROUP_READ OWNER_READ
         DESTINATION bin)


ADD_EXECUTABLE(pfsview ${pfsview_SOURCES} 
    ${pfsview_HEADERS_MOC} "${GETOPT_OBJECT}")
TARGET_LINK_LIBRARIES(pfsview pfs ${QT_LIBRARIES} ${QT_QTCORE_LIBRARY} ${QT_QTGUI_LIBRARY})

install (TARGETS pfsview DESTINATION bin)
install (FILES pfsview.1 DESTINATION ${MAN_DIR})

=== src/tmo/ferradans11/CMakeLists.txt ===
include_directories ("${PROJECT_BINARY_DIR}/"
"${PROJECT_SOURCE_DIR}/src/pfs" "${PROJECT_SOURCE_DIR}/src/tmo/pfstmo")

if( NOT HAS_GETOPT )
	include_directories ("${GETOPT_INCLUDE}")
endif( NOT HAS_GETOPT )

link_directories("${PROJECT_SOURCE_DIR}/src/pfs")

set(TRG pfstmo_ferradans11)
add_executable(${TRG} ${TRG}.cpp Imagen.cpp tmo_ferradans11.cpp "${GETOPT_OBJECT}")
target_link_libraries(${TRG} pfs ${FFTW_LIBS})
install (TARGETS ${TRG} DESTINATION bin)
install (FILES ${TRG}.1 DESTINATION ${MAN_DIR})

=== src/tmo/mantiuk08/CMakeLists.txt ===
include_directories ("${PROJECT_BINARY_DIR}/"
"${PROJECT_SOURCE_DIR}/src/pfs" "${PROJECT_SOURCE_DIR}/src/tmo/pfstmo" "${GSL_INCLUDE_DIR}")

if( NOT HAS_GETOPT )
	include_directories ("${GETOPT_INCLUDE}")
endif( NOT HAS_GETOPT )

link_directories("${PROJECT_SOURCE_DIR}/src/pfs")

set(TRG pfstmo_mantiuk08)
add_executable(${TRG} ${TRG}.cpp display_adaptive_tmo.cpp display_function.cpp display_size.cpp cqp/cqpminimizer.cpp cqp/initial_point.cpp cqp/mg_pdip.cpp "${GETOPT_OBJECT}")
target_link_libraries(${TRG} pfs ${GSL_LIBRARIES})
install (TARGETS ${TRG} DESTINATION bin)
install (FILES ${TRG}.1 DESTINATION ${MAN_DIR})

## pfstools 1.8.5

=== debian/changelog ===
pfstools (1.8.5-1) unstable; urgency=low

  * debian/rules:
    - Split 'build' target into 'build-arch' and 'build-indep'.
    - Use dpkg-buildflags to get build flags.
  * debian/control:
    - Updated standards-version to 3.9.3.
  * debian/copyright:
    - Updated for upstream version 1.8.5.
  * debian/patches/:
    - Added Wformat-security.dpatch, fixing some issues identified by
      -Wformat-security.

 -- Sebastian Harl <tokkee@debian.org>  Sat, 30 Jun 2012 14:48:49 +0200

pfstools (1.8.5-0.1) unstable; urgency=low

  * Non-maintainer upload.

  [ Sébastien Villemot ]
  * New upstream release, build-depend on Qt4 instead of Qt3 (Closes: #604368)
  * gcc-4.4.dpatch: remove patch, applied upstream
  * Convert to format 3.0 (quilt) and drop dpatch, because otherwise Lintian
    produces an error (dpatch is obsolete)

  [ Rafael Laboissiere ]
  * debian/control:
    - Build-depend on liboctave-dev, such that the package builds with
      Octave 3.6 (Closes: #666959)
    - Depend simply on octave, do not use the obsolete ${octave:Depends}
      substitution variable anymore
  * debian/rules:
    - Use directly the octave-config script in order to get the
      installation path for the *.oct and *.m files
    - Do not invoke the obsolete script octave-depends
  * debian/octave-pfstools.install: Adjust for the multiarch path, which
    contains the architecture triplet now

 -- Sébastien Villemot <sebastien.villemot@ens.fr>  Sun, 03 Jun 2012 11:00:46 +0200

pfstools (1.8.1-2) unstable; urgency=low

  [ Thomas Weber ]
  * Switch to octave3.2 (Closes: #567875).

  [ Sebastian Harl ]
  * debian/control:
    - Updated standards-version to 3.8.4 -- no changes.
    - Let libpfs-dev depend on libpfs (= ${binary:Version}) (rather than a
      weak dependency on >= ${source:Version}).
    - Let all packages depend on ${misc:Depends}.
  * Added debian/README.source:
    - The file includes a pointer to /usr/share/doc/dpatch/README.source.gz.

 -- Sebastian Harl <tokkee@debian.org>  Mon, 15 Mar 2010 22:50:05 +0100

pfstools (1.8.1-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Add patch gcc-4.4.dpatch, to fix FTBFS w/ gcc 4.4, rationale; patch
    from Ubuntu (with some extra comments/rationale by me).
    (Closes: #554494)

 -- Stefano Zacchiroli <zack@debian.org>  Sun, 20 Dec 2009 15:12:00 +0100

pfstools (1.8.1-1) unstable; urgency=low

  * New upstream release.
  * debian/patches:
    - Removed dcraw-m.dpatch - merged upstream.
    - Removed octave3.0.dpatch - merged upstream.
    - Added octave-nargin.dpatch - this patch lets octave scripts use the
      variable nargin instead of length(argv); the latter does not work
      reliably when no command line arguments have been specified.
    - Added octave-signal.dpatch - this patch lets pfsstat bail out with an
      error message if gausswin() is not available, telling the user to
      install octave-signal.
  * Removed debian/pfsglview.1 - included upstream.
  * debian/control:
    - Added libmagick++-dev as an option to the libmagick++9-dev build
      dependency.
    - Updated Standards-Version to 3.8.1 - no changes.
    - Changed section of package 'pfstools-dbg' to the newly added section
      'debug'.
    - Build-depend on texlive-latex-base rather than the obsolete tetex-bin.
    - Updated homepage.
    - Let pfstools recommend octave-signal which is required by pfsstat.
  * debian/pfsglview.install:
    - Install the pfsglview.1 manpage.
  * debian/pfstools.install:
    - Install usr/share/pfstools/hdrhtml_*.
  * debian/rules:
    - Use dh_install's --fail-missing instead of --list-missing.
    - Explicitly disable all features that are not available to ensure
      consistent builds - currently this is matlab, jpeghdr and gdal.
    - Pass CXXFLAGS as arguments to configure instead of setting them in the
      environment - this is the recommended way.
  * debian/control, debian/rules:
    - Use ${octave:Depends} and octave3.0-depends instead of explicitly
      depending on octave3.0.

 -- Sebastian Harl <tokkee@debian.org>  Mon, 08 Jun 2009 20:41:22 +0200

pfstools (1.6.4-2) unstable; urgency=low

  * Switched to octave3.0, thanks to Thomas Weber for the patches
    (Closes: #458131).
    - Added octave3.0.dpatch including required changes for octave 3.0.
  * Added dcraw-m.dpatch which fixes the usage of dcraw's "-m" command line
    option (Closes: #464724).

 -- Sebastian Harl <sh@tokkee.org>  Mon, 31 Mar 2008 16:38:54 +0200

pfstools (1.6.4-1) unstable; urgency=low

  * New upstream release.
    - Added missing includes required by gcc-4.3 (Closes: #455648).
  * Downgraded pfstool's requirement on octave{,pfstools} to a recommendation
    (Closes: #445909).
  * Added new binary packages for pfsglview and pfsview to prevent users from
    having to install OpenGL/GLUT and Qt.
  * Removed a bashism from debian/rules (Closes: #456508).
  * Renamed "XS-Vcs-*" fields to Vcs-* and moved "Homepage" field from the
    package description to the source stanza:
    - Added versioned build dependency on dpkg-dev (>= 1.14.6).
  * Updated to standards version 3.7.3 (no changes).
  * Changed maintainer to pkg-phototools team:
    - Moved myself to uploaders.
  * Added a watch file, thanks to Cyril Brulebois.

 -- Sebastian Harl <sh@tokkee.org>  Sun, 27 Jan 2008 17:33:12 +0100

pfstools (1.6.2-1) unstable; urgency=low

  * Initial release (Closes: #399503, #410669).
  * Added pfsglview.1 from upstream CVS.

 -- Sebastian Harl <sh@tokkee.org>  Fri, 10 Aug 2007 15:00:06 +0200

=== debian/control ===
Source: pfstools
Section: graphics
Priority: optional
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders: Sebastian Harl <tokkee@debian.org>
Build-Depends: debhelper (>= 5), dpkg-dev (>= 1.14.6), gfortran, autotools-dev, libqt4-dev, libmagick++-dev | libmagick++9-dev, libtiff4-dev, libopenexr-dev, libnetpbm10-dev, liboctave-dev, texlive-latex-base, freeglut3-dev
Standards-Version: 3.9.3
Homepage: http://pfstools.sourceforge.net/
Vcs-Git: git://git.debian.org/git/pkg-phototools/pfstools.git
Vcs-Browser: http://git.debian.org/?p=pkg-phototools/pfstools.git

Package: pfstools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: pfsglview | pfsview, pfstmo, octave, octave-signal, octave-pfstools
Suggests: dcraw, exrtools, imagemagick
Description: command line HDR manipulation programs
 pfstools is a set of command line (and two GUI) programs for reading,
 writing, manipulating and viewing high-dynamic range (HDR) images and video
 frames. All programs in this package exchange data using a simple generic
 file format (pfs) for HDR data. It is an attempt to integrate existing file
 formats by providing a simple data format that can be used to exchange data
 between applications.
 .
 The concept of pfstools is similar to netpbm for low-dynamic range images.

Package: pfsglview
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: pfstools
Replaces: pfstools (<< 1.6.2-2)
Description: command line HDR manipulation programs (OpenGL/GLUT viewer)
 PFS is a high-dynamic range (HDR) image format. It is an attempt to integrate
 existing file formats by providing a simple data format that can be used to
 exchange data between applications.
 .
 This package contains a viewer implemented in OpenGL/GLUT.

Package: pfsview
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: pfstools
Replaces: pfstools (<< 1.6.2-2)
Description: command line HDR manipulation programs (Qt viewer)
 PFS is a high-dynamic range (HDR) image format. It is an attempt to integrate
 existing file formats by providing a simple data format that can be used to
 exchange data between applications.
 .
 This package contains a viewer implemented in Qt.

Package: pfstools-dbg
Section: debug
Architecture: any
Priority: extra
Depends: pfstools (= ${binary:Version}), pfsglview (= ${binary:Version}),
 pfsview (= ${binary:Version}), libpfs-1.2-0 (= ${binary:Version}),
 ${misc:Depends}
Description: command line HDR manipulation programs (debugging symbols)
 PFS is a high-dynamic range (HDR) image format. It is an attempt to integrate
 existing file formats by providing a simple data format that can be used to
 exchange data between applications.
 .
 This package contains the debugging symbols for the pfstools binaries and the
 shared library.

Package: libpfs-dev
Section: libdevel
Architecture: any
Depends: libpfs-1.2-0 (= ${binary:Version}), ${misc:Depends}
Description: C++ library to read and write pfs files (development files)
 PFS is a high-dynamic range (HDR) image format. It is an attempt to integrate
 existing file formats by providing a simple data format that can be used to
 exchange data between applications. This library can be used to write custom
 applications that can integrate with the existing pfstools programs.
 .
 This package contains the header files and the static library.

Package: libpfs-1.2-0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ library to read and write pfs files
 PFS is a high-dynamic range (HDR) image format. It is an attempt to integrate
 existing file formats by providing a simple data format that can be used to
 exchange data between applications. This library can be used to write custom
 applications that can integrate with the existing pfstools programs.
 .
 This package contains the shared library.

Package: octave-pfstools
Section: math
Architecture: any
Depends: octave, ${shlibs:Depends}, ${misc:Depends}
Description: octave bindings for pfstools
 PFS is a high-dynamic range (HDR) image format. It is an attempt to integrate
 existing file formats by providing a simple data format that can be used to
 exchange data between applications.
 .
 This package contains octave bindings to read and write PFS files.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for pfstools
#
# Written by Sebastian Harl <tokkee@debian.org>

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

CPPFLAGS = $(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS = $(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS = $(shell dpkg-buildflags --get CXXFLAGS)
CXXFLAGS += -Wall

MDIR = $(shell octave-config  --print LOCALFCNFILEDIR)
OCTDIR = $(shell octave-config  --print LOCALOCTFILEDIR)

confflags = --host=$(DEB_HOST_GNU_TYPE) \
			--build=$(DEB_BUILD_GNU_TYPE) \
			--prefix=/usr \
			--mandir=\$${prefix}/share/man \
			--with-octave-m-dir=$(MDIR)/pfstools \
			--with-octave-oct-dir=$(OCTDIR)/pfstools

# Matlab is not available in Debian.
confflags += --disable-matlab

# These libraries are not available / unusable in Debian.
confflags += --disable-jpeghdr --disable-gdal

config.status: configure
	dh_testdir
	
	for file in config.guess config.sub; do \
		if [ ! -e $$file.upstream ]; then \
			mv $$file $$file.upstream; \
			ln -s /usr/share/misc/$$file .; \
		fi \
	done
	
	./configure $(confflags) CPPFLAGS="$(CPPFLAGS)" CFLAGS="$(CFLAGS)" \
		CXXFLAGS="$(CXXFLAGS)"

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp

build-stamp: config.status
	dh_testdir
	
	$(MAKE)
	
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	
	[ ! -f Makefile ] || $(MAKE) clean
	[ ! -f Makefile ] || $(MAKE) distclean
	
	for file in config.guess config.sub; do \
		if [ -e $$file.upstream ]; then \
			rm -f $$file; \
			mv $$file.upstream $$file; \
		fi \
	done
	
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
	
	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp install
	
	chmod 644 debian/tmp/$(MDIR)/pfstools/*
	
	# these binaries are not available
	rm debian/tmp/usr/share/man/man1/pfs*jpeghdr.1
	rm debian/tmp/usr/share/man/man1/pfsingdal.1

binary-indep: build install
	# nothing to do here

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs README TODO doc/faq.txt doc/pfs_format_spec.pdf
	dh_installdocs -A AUTHORS
	dh_installexamples
	dh_install --sourcedir=debian/tmp --fail-missing
	# these files have been installed twice by dh_install
	rm -f debian/pfstools/usr/bin/pfs*view debian/pfstools/usr/bin/pfsv \
		debian/pfstools/usr/share/man/man1/pfsv.1 \
		debian/pfstools/usr/share/man/man1/pfs*view.1
	dh_installman
	dh_link
	dh_strip --dbg-package=pfstools-dbg
	# mkoctfile removes any symbol table and relocation information from the
	# .oct files making them unusable for the -dbg package
	rm -rf debian/pfstools-dbg/usr/lib/debug/usr/lib/octave/
	dh_compress -X.pdf
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps -Llibpfs-1.2-0 -ldebian/libpfs-1.2-0/usr/lib/
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

=== debian/watch ===
version=3

http://sf.net/pfstools/pfstools-([0-9.]+)\.tar\.gz

## pfstools 2.0.4

=== debian/changelog ===
pfstools (2.0.4-5build1) xenial; urgency=medium

  * Rebuild against new gsl SONAME change.

 -- Michael Terry <mterry@ubuntu.com>  Tue, 08 Dec 2015 10:14:08 -0500

pfstools (2.0.4-5) unstable; urgency=medium

  [ Bas Couwenberg ]
  * Update build dependencies for GSL 2, change libgsl0-dev to libgsl-dev.
    Closes: #807221

 -- Andreas Metzler <ametzler@debian.org>  Mon, 07 Dec 2015 07:59:39 +0100

pfstools (2.0.4-4) unstable; urgency=medium

  * Upload to unstable.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 01 Nov 2015 17:48:11 +0100

pfstools (2.0.4-3) experimental; urgency=medium

  * There is no use for a separate build-indep target in debian/rules if there
    are no arch-indep packages to build.

 -- Andreas Metzler <ametzler@debian.org>  Thu, 29 Oct 2015 19:31:04 +0100

pfstools (2.0.4-2) experimental; urgency=medium

  * Disable parallel build to fix FTBFS.

 -- Andreas Metzler <ametzler@debian.org>  Wed, 28 Oct 2015 19:24:18 +0100

pfstools (2.0.4-1) experimental; urgency=medium

  * Watchfile matches on .tgz in addition to tar.gz.
  * Switch to dh, and debhelper compat level 9.
  * Drop outdated and superfluous README.source.
  * New upstream version.
  * Updated upstream build-system:
    + Update build-depends and rules for cmake.
    + Manually build LaTeX docs, ignored by upstream build-system.
    + cmake build only supports building either shared or static lib, instead
      of both, build shared one and update libpfs-dev.install. accordingly.
      la-file is gone, too.
    + The cmake build-system does not easily support multi-arch, revert
      *.install again.
  * Drop Wformat-security.dpatch, 20_stop_overriding_CXXFLAGS.diff and
    octave-4.0.diff.
  * Add 21_fedora_maptype.patch from Fedora to fix octave related FTBFS.
  * Add 22_octave_install_dirs.patch, to allow specifying separate target
    directories for octave dynamic-link libraries and octave .m script files.
    Use these variables in debian/rules.
  * Upstream soname-bump: libpfs-1.2-0 -> libpfs2, packages renamed.
  * pfstmo has been integrated into pfstools, take over binary package and add
    b-d on libgsl0-dev (needed for pfstmo_mantiuk08).
  * Register pfs_format_spec.pdf with doc-base.
  * Add debian/missing-sources/mootools-1.2.4.js.
  * Link with -Wl,--as-needed.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 24 Oct 2015 13:12:42 +0200

pfstools (1.8.5-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * d/p/octave-4.0.diff: new patch, fixes FTBFS against Octave 4.0.
    (Closes: #792890)

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 20 Jul 2015 20:17:58 +0200

pfstools (1.8.5-2) unstable; urgency=medium

  [ Jackson Doak ]
  * debian/control:
    - Use canonical git urls
    - Change libtiff4-dev to libtiff-dev. Closes: #736037, #681824 
    - Drop alternate build-depend on libmagick++9-dev, it no longer exists 

  [ Andreas Metzler ]
  * Upload to unstable to prevent removal from testing.
  * Add myself to uploaders.
  * Use dh-autoreconf instead of autotools-dev to also fix FTBFS on ppc64el by
    getting new libtool macros (still updates config.{sub,guess}). (Thanks,
    Logan Rosen) Closes: #737668
  * Use Debian's default LDFLAGS.
  * 20_stop_overriding_CXXFLAGS.diff: Stop
    ./configure --enable-debug/--disable-debug from changing CXXFLAGS (either
    disable all optimisation and use -g, or disable -g and set -O3) apart from
    prepending -g for --enable-debug.  (Fixes lintian's
    debug-file-with-no-debug-symbols warning.)

 -- Andreas Metzler <ametzler@debian.org>  Sat, 02 Aug 2014 18:45:56 +0200

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,15 @@
 Section: graphics
 Priority: optional
 Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
-Uploaders: Sebastian Harl <tokkee@debian.org>
-Build-Depends: debhelper (>= 5), dpkg-dev (>= 1.14.6), gfortran, autotools-dev, libqt4-dev, libmagick++-dev | libmagick++9-dev, libtiff4-dev, libopenexr-dev, libnetpbm10-dev, liboctave-dev, texlive-latex-base, freeglut3-dev
-Standards-Version: 3.9.3
+Uploaders: Sebastian Harl <tokkee@debian.org>, Andreas Metzler <ametzler@debian.org>
+Build-Depends: debhelper (>= 9), gfortran,
+ cmake, libqt4-dev, libmagick++-dev, libtiff-dev, libopenexr-dev,
+ libnetpbm10-dev, liboctave-dev, texlive-latex-base, freeglut3-dev,
+ libgsl-dev
+Standards-Version: 3.9.6
 Homepage: http://pfstools.sourceforge.net/
-Vcs-Git: git://git.debian.org/git/pkg-phototools/pfstools.git
-Vcs-Browser: http://git.debian.org/?p=pkg-phototools/pfstools.git
+Vcs-Git: git://anonscm.debian.org/pkg-phototools/pfstools.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-phototools/pfstools.git
 
 Package: pfstools
 Architecture: any
@@ -53,7 +56,7 @@
 Architecture: any
 Priority: extra
 Depends: pfstools (= ${binary:Version}), pfsglview (= ${binary:Version}),
- pfsview (= ${binary:Version}), libpfs-1.2-0 (= ${binary:Version}),
+ pfsview (= ${binary:Version}), libpfs2 (= ${binary:Version}),
  ${misc:Depends}
 Description: command line HDR manipulation programs (debugging symbols)
  PFS is a high-dynamic range (HDR) image format. It is an attempt to integrate
@@ -66,7 +69,7 @@
 Package: libpfs-dev
 Section: libdevel
 Architecture: any
-Depends: libpfs-1.2-0 (= ${binary:Version}), ${misc:Depends}
+Depends: libpfs2 (= ${binary:Version}), ${misc:Depends}
 Description: C++ library to read and write pfs files (development files)
  PFS is a high-dynamic range (HDR) image format. It is an attempt to integrate
  existing file formats by providing a simple data format that can be used to
@@ -75,7 +78,7 @@
  .
  This package contains the header files and the static library.
 
-Package: libpfs-1.2-0
+Package: libpfs2
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -98,3 +101,18 @@
  .
  This package contains octave bindings to read and write PFS files.
 
+Package: pfstmo
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Recommends: pfstools
+Description: set of tone mapping operators
+ This package contains a set of state-of-the-art tone mapping operators. Tone
+ mapping is a technique used to approximately map the appearance of
+ high-dynamic range (HDR) images to media with more limited dynamic range. The
+ operators are suitable for processing of both static images and animations.
+ .
+ The operators are embedded in a flexible framework (pfstools) which provides
+ a unified input/output mechanism and a modular architecture for the filtering
+ of the image data. Various file formats for static images and video are
+ transparently supported and the High Dynamic Range data are processed
+ modularly through a Unix piping mechanism.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for pfstools
#
# Written by Sebastian Harl <tokkee@debian.org>

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

MDIR = $(shell octave-config  --print LOCALFCNFILEDIR)
OCTDIR = $(shell octave-config  --print LOCALOCTFILEDIR)
export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

confflags = -DCMAKE_EXPORT_COMPILE_COMMANDS=true -DBUILD_SHARED_LIBS=ON \
	    -DOCTAVE_OCT_DIR=$(OCTDIR)/pfstools \
	    -DOCTAVE_M_DIR=$(MDIR)/pfstools
#	    -DLIB_DIR=/usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
# Matlab is not available in Debian.
confflags += -DWITH_MATLAB=false

# These libraries are not available / unusable in Debian.
#confflags += --disable-jpeghdr --disable-gdal

export DEB_CFLAGS_MAINT_APPEND := -Wall
export DEB_CXXFLAGS_MAINT_APPEND := -Wall

override_dh_auto_configure:
	dh_auto_configure --verbose -- \
		$(confflags)

override_dh_auto_build:
	dh_auto_build -v
	cd doc && pdflatex pfs_format_spec.tex && \
		pdflatex pfs_format_spec.tex

override_dh_auto_install:
	dh_auto_install --verbose
	chmod 644 debian/tmp/$(MDIR)/pfstools/*
	# these binaries are not available
	rm -vf debian/tmp/usr/share/man/man1/pfs*jpeghdr.1 \
		debian/tmp/usr/share/man/man1/pfsingdal.1

override_dh_install:
	dh_install
	# these files have been installed twice by dh_install
	rm -vf debian/pfstools/usr/bin/pfs*view debian/pfstools/usr/bin/pfsv \
		debian/pfstools/usr/share/man/man1/pfsv.1 \
		debian/pfstools/usr/share/man/man1/pfs*view.1 \
		debian/pfstools/usr/bin/pfstmo* \
		debian/pfstools/usr/share/man/*/pfstmo*

override_dh_strip:
	dh_strip --dbg-package=pfstools-dbg
	# mkoctfile removes any symbol table and relocation information from the
	# .oct files making them unusable for the -dbg package
	rm -rf debian/pfstools-dbg/usr/lib/debug/usr/lib/octave/

override_dh_compress:
	dh_compress -X.pdf

%:
	dh $@

=== debian/watch ===
version=3

http://sf.net/pfstools/pfstools-([0-9.]+)\.(?:tar\.gz|tgz)
